<?php

/**
 * Integration with tagDiv Composer
 */

namespace Clickio\Integration\Services;

use Clickio\Integration\Interfaces\IIntegrationService;
use Clickio\Utils\SafeAccess;

/**
 * Integration with tagDiv Composer
 *
 * @package Integration\Services
 */
final class TdComposer extends AbstractIntegrationService implements IIntegrationService
{

    /**
     * Plugin unique key
     * Directory name in WP plugins catalog
     * is unique and cannot be modified
     *
     * @var string
     */
    const PLUGIN_ID = 'td-composer/td-composer.php';

    /**
     * Service alias
     *
     * @var string
     */
    protected static $alias = 'td_composer';

    /**
     * Get post primary category
     *
     * @param int $post_id WP_Post->ID
     *
     * @return int|string
     */
    public static function getPrimaryTerm(int $post_id)
    {
        if (!static::integration()) {
            return 0;
        }

        $meta = get_post_meta($post_id, 'td_post_theme_settings', true);
        $meta_field = SafeAccess::fromArray($meta, 'td_primary_cat', 'mixed', 0);
        return $meta_field;
    }
}