<?php
/**
 * Listing builder interface
 */

namespace Clickio\Listings\Interfaces;

use Clickio\Listings\FilterListingContainer;
use Clickio\Listings\FilterParamsContainer;

/**
 * Listing builder interface
 *
 * @package Listings\Interfaces
 */
interface IListingBuilder
{
    /**
     * Builder main function
     *
     * @param FilterParamsContainer $container query result
     *
     * @return FilterListingContainer
     */
    public function build(FilterParamsContainer $container): FilterListingContainer;

    /**
     * Get builder alias
     *
     * @return string
     */
    public static function getAlias(): string;
}