<?php
/**
 * Wordpress config
 */

namespace Clickio\Utils;

/**
 * Wordpress config class
 *
 * @package Utils
 */
final class WpConfig
{

    /**
     * Get complete wordpress config
     *
     * @return array
     */
    public static function getFullConfig(): array
    {
        $conf = [
            "comments" => [
                "moderation" => !empty(get_option('comment_moderation')),
                "status" => static::commentsAreOpen(),
                "require_name_email" => !empty(get_option('require_name_email')),
                "show_avatars" => !empty(get_option("show_avatars"))
            ]
        ];
        return $conf;
    }

    /**
     * Get comments status
     *
     * @param int $post_id post id
     *
     * @return bool
     */
    public static function commentsAreOpen(int $post_id = 0): bool
    {
        $status = get_option('default_comment_status') == 'open';
        if (LocationType::isPost() || LocationType::isPage()) {
            $status = comments_open($post_id);
        }
        return $status;
    }
}